﻿using System;
using System.Data;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

/// <summary>
/// Summary description for ModelFacade
/// </summary>
public class ModelFacade
{
	public ModelFacade()
	{
		//
		// TODO: Add constructor logic here
		//
	}
    
    public ClaimDTO createClaim(ClaimFormDTO formData)
    {
// get the policy number and look for a matching policy in the database
        int policyNumber = formData.policyNumber;
        PolicyDAO policyDAO = new PolicyDAO();
        PolicyDTO policy = policyDAO.getPolicyByNumber(policyNumber);
        if(policy == null)
            return null;
     // if we find a match, create a Claim and link it to the policy  
        ClaimDTO claim = new ClaimDTO();
        ReferenceGenerator generator = new ReferenceGenerator();
        if (formData.amount == null) formData.amount = 0;
        claim.amount = formData.amount;
        if (formData.description == null) formData.description = "";
        claim.description = formData.description;
        claim.claimDate = DateTime.Now;
        claim.isApproved = false;
        String reference = generator.getReference(formData, policy);
        claim.reference = reference;
        claim.policyID = policy.policyID;
 // write the claim to the database
        ClaimDAO claimDAO = new ClaimDAO();
        claimDAO.saveClaim(claim);
 // set up the foreign key in the database
        claimDAO.linkToPolicy(claim, policy);
 // link the two objects
        claim.policy = policy;
 // return the claim, associated with the policy
        return claim;
    }

//    public double getQuote(BuildingsDTO dto)
//    {
//        QuoteProcessor quoter = new QuoteProcessor();
//        return quoter.getBuildingsQuote(dto);
//    }
//
//    public double getQuote(ContentsDTO dto)
//    {
//        QuoteProcessor quoter = new QuoteProcessor();
//        return quoter.getContentsQuote(dto);
//    }

    public List<ClaimDTO> getClaims(String whereClause)
    {
        ClaimDAO myDAO = getClaimDAO();
        List<ClaimDTO> claimCollection = myDAO.getClaimList(whereClause);
        return claimCollection;
    }

    public ClaimDTO getClaimByRef(String reference)
    {
        ClaimDAO myDAO = getClaimDAO();
        return myDAO.getClaimByRef(reference);
    }

    public void updateClaim(ClaimDTO claim)
    {
        ClaimDAO myDAO = getClaimDAO();
        myDAO.updateClaim(claim);
    }

    public void deleteClaim(ClaimDTO claim)
    {
        ClaimDAO myDAO = getClaimDAO();
        myDAO.deleteClaim(claim);
    }

    public PolicyDTO getPolicy(int policyNumber)
    {
        PolicyDAO myDAO = getPolicyDAO();
        PolicyDTO myDTO = myDAO.getPolicyByNumber(policyNumber);
        return myDTO;
    }

    private ClaimDAO getClaimDAO()
    {
        ClaimDAO myDAO = new ClaimDAO();
        return myDAO;
    }
    private PolicyDAO getPolicyDAO()
    {
        PolicyDAO myDAO = new PolicyDAO();
        return myDAO;
    }
}
